
//#include "Lab_Uino_inc.h"
typedef unsigned(__stdcall *PTHREAD_START)(void *);

#define chBEGINTHREADEX(psa, cbStack, pfnStartAddr, \
   pvParam, fdwCreate, pdwThreadId)                 \
      ((HANDLE)_beginthreadex(                      \
         (void *)        (psa),                     \
         (unsigned)      (cbStack),                 \
         (PTHREAD_START) (pfnStartAddr),            \
         (void *)        (pvParam),                 \
         (unsigned)      (fdwCreate),               \
(unsigned *)(pdwThreadId)))

typedef int ( __stdcall *pf1)(void);
typedef int ( __stdcall *pf2)(unsigned char * buffer);
typedef int ( __stdcall *pf3)(unsigned char data);
typedef int ( __stdcall *pf4)(unsigned char led_num,unsigned char valor);
typedef int ( __stdcall *pf5)(unsigned short data);

int __stdcall Open_Lab(void);
int __stdcall Read_Buf(unsigned char * Usb_rx_buffer);
int __stdcall Write_Buf(unsigned char * Usb_tx_buffer);
int __stdcall Read_Keys(void);
int __stdcall Read_ADC(unsigned char adc_num);
int __stdcall Write_Data_Led(unsigned char data);
int __stdcall Write_Ctr_Led(unsigned char data);
int __stdcall Led_On(unsigned char led_num);
int __stdcall Led_Off(unsigned char led_num);
int __stdcall Led_Toggle(unsigned char led_num);
int __stdcall Led_Wr(unsigned char led_num,unsigned char valor);
int __stdcall Read_Key(unsigned char key_num);
int __stdcall pwm_A(unsigned short valor);
int __stdcall pwm_B(unsigned short valor);
int __stdcall pwm_C(unsigned short valor);
int __stdcall Close_Lab(void);

	pf1 open_lab=NULL;
	pf2 read_buf=NULL;
	pf2 write_buf=NULL;
	pf1 read_keys=NULL;
	pf3 read_adc=NULL;
	pf3 write_data_led=NULL;
	pf3 write_ctr_led=NULL;
	pf3 led_on=NULL;
	pf3 led_off=NULL;
	pf3 led_toggle=NULL;
	pf4 led_wr=NULL;
	pf5 pwm_a=NULL;
	pf5 pwm_b=NULL;
    pf5 pwm_c=NULL;
    pf3 read_key=NULL;
	pf1 close_lab=NULL;



  unsigned char Usb_buffer[10];
  HINSTANCE hLib;

int load_kit(void)
{
    hLib = LoadLibrary("Lab_Uino.dll");

  if(hLib==NULL)
    {
    printf("\n\rErro ao abrir arquivo Lab_Uino.dll");
    return 1;
    }


    char dllpath[70];

    GetModuleFileName((HMODULE)hLib,(LPTSTR)dllpath,70);

    printf("\n\rDll loaded:");

	open_lab = (pf1)GetProcAddress(hLib, "Open_Lab");
	read_buf= (pf2)GetProcAddress(hLib, "Read_Buf");
	write_buf= (pf2)GetProcAddress(hLib, "Write_Buf");
	read_keys= (pf1)GetProcAddress(hLib, "Read_Keys");
	read_adc= (pf3)GetProcAddress(hLib, "Read_ADC");
	write_data_led= (pf3)GetProcAddress(hLib, "Write_Data_Led");
	write_ctr_led= (pf3)GetProcAddress(hLib, "Write_Ctr_Led");
	led_on= (pf3)GetProcAddress(hLib, "Led_On");
	led_off= (pf3)GetProcAddress(hLib, "Led_Off");
	led_toggle= (pf3)GetProcAddress(hLib, "Led_Toggle");
	led_wr= (pf4)GetProcAddress(hLib, "Led_Wr");
	pwm_a= (pf5)GetProcAddress(hLib, "pwm_A");
	pwm_b= (pf5)GetProcAddress(hLib, "pwm_B");
	pwm_c= (pf5)GetProcAddress(hLib, "pwm_C");
    read_key= (pf3)GetProcAddress(hLib, "Read_Key");
	close_lab= (pf1)GetProcAddress(hLib, "Close_Lab");
	

	open_lab();
    return 0;
}

void stop_kit(){

	close_lab();
    FreeLibrary((HMODULE)hLib);
     }
